!
!  :
!
! http://www.zint.org.uk  -   Zint, 
!
!      :
! https://online-barcode-reader.inliteresearch.com/ -     
! https://www.onlinebarcodereader.com/ -   
! http://www.sbqr.ru/validator/index.html -   
!
!   -   (picStr)  zint.ZS.bitmap  Bitmap  (RGB)
!  (zint.ZS.bitmap_width)*(zint.ZS.bitmap_height)*3    24
!
 
   Program
 
   Include ('zint_class.inc'), once

   Map
   
      Module('winapi')
         LoadLibrary    (*cstring lpLibFileName), long, raw, Pascal, dll(1), name('LoadLibraryA')             
         GetProcAddress (long hModule, *cstring lpProcName), long, raw, Pascal, dll(1)
         FreeLibrary    (long hLibModule), long, Pascal, dll(1), Proc
         memcpy(long dest, long src, long), long, Proc, name('_memcpy')

         GetLastError(), long, Pascal, dll(1)
         SendMessage(long hWnd, ulong Msg, ulong wParam, long lParam), long, Pascal, dll(1), name('SendMessageA'), Proc
         MultiByteToWideChar(ulong CodePage, ulong dwFlags, long lpMultiByteStr, long cbMultiByte, long lpWideCharStr, long cchWideChar), long, Pascal, Proc

         OpenClipboard(long hWndNewOwner), long, Pascal, dll(1), Proc
         EmptyClipboard(), long, Pascal, dll(1), Proc
         SetClipboardData(ulong uFormat, long hMem), long, Pascal, raw, dll(1)
         GetClipboardData(ulong uFormat), long, Pascal, dll(1)
         CloseClipboard(), long, Pascal, dll(1), Proc
         LocalAlloc(ulong uFlags, ulong uBytes), long, Pascal, dll(1)
      .

      Module('msvcrt')
         fsize  (long fd), long, C, dll(1), name('f_size')
         fopen  (*cstring filename, long access=4000h), long, raw, C, dll(1), name('f_open')
         fread  (long fd, *string buf, ulong count), long, raw, C, dll(1), Proc, name('f_read')
         fclose (long fd), long, raw, C, dll(1), Proc, name('f_close')
      .

      view_code(any testN, any comment, any code_text, *string pic_Str, string filename, long w_pic, long h_pic, long rotate)
      load_file(any filename, *long filelength), *string
      load_libs(), long, Private
      str_to_UTF16(string filename, ulong CP_input, long hwnd)
      clear_Clipboard(long hwnd)

   .

zint &zintClass

stxt      string(2048)
ref_stxt  &string

ctxt      cstring(2048)
ref_ctxt  &cstring

input_filename   string(256)
output_filename  string(256)
how_to_clip      long
rotate_angle     long
AU               long
pixel_format     long
picStr           &string  !             

is_UTF16        long(0)  !  is_UTF16=1   View_Code()    ?Rtf    UTF-16

! msvcrt.dll
adr_msvcrt  long
h_size      long, name('f_size')
h_open      long, name('f_open')
h_read      long, name('f_read')
h_close     long, name('f_close')

   Code
      
      zint &= new zintClass
      err# = zint.ZB_Create()
      If err# then stop(err#).
      
      ret# = load_libs()


! -------------------------------------------------------------------------------------------------------------------------
! -------------------------------------------------------------------------------------------------------------------------
! ZB_Str_Image() -  -          .   -   .
! -------------------------------------------------------------------------------------------------------------------------
! -------------------------------------------------------------------------------------------------------------------------
     
! test1 -------------------------------------------------------------------------------------------------------------------
!  (EAN-8),    (test1.bmp),    (picStr)

      zint.ZS.whitespace_width = 5
      zint.ZS.border_width = 5
      zint.ZS.symbology = BARCODE_EANX

      stxt = '6921101'

      output_filename = 'test1.bmp'

      how_to_clip = -11
      rotate_angle = 270
      AU = 0
      pixel_format = 1
      
      picStr &= zint.ZB_Str_Image(stxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test1', 'EAN-8', clip(stxt), picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test2 -------------------------------------------------------------------------------------------------------------------
!  (EAN-13),    (test2.gif),    (picStr)

      zint.ZS.fgcolour = '0000C0' 
      zint.ZS.bgcolour = 'C0FFC0'
      zint.ZS.whitespace_width = 12
      zint.ZS.border_width = 2
      zint.ZS.scale = 1
      zint.ZS.symbology = BARCODE_EANX

      ctxt = '967920036952'

      output_filename = 'test2.gif'

      how_to_clip = -11
      rotate_angle = 0
      AU = 0
      pixel_format = 8

      picStr &= zint.ZB_Str_Image(ctxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test2', 'EAN-13', ctxt, picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test3 -------------------------------------------------------------------------------------------------------------------
!  (BARCODE_EAN),    (test3.jpeg),    (picStr)

      zint.ZS.fgcolour = 'FFFFFF'
      zint.ZS.bgcolour = '000000'
      zint.ZS.whitespace_width = 5
      zint.ZS.border_width = 2
      zint.ZS.scale = 1
      zint.ZS.symbology = BARCODE_EANX

      zint.ZS.output_options = SMALL_TEXT
      zint.ZS.fontsize = 15

      stxt = '7432365+54321'
      ref_stxt &= stxt

      output_filename = 'test3.jpeg'

      how_to_clip = -11
      rotate_angle = 0
      AU = 1
      pixel_format = 24

      picStr &= zint.ZB_Str_Image(ref_stxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test3', 'EAN-8 + EAN-5', ref_stxt, picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test4 -------------------------------------------------------------------------------------------------------------------
!  (Data Matrix),    (test4.png),    (picStr)

      zint.ZS.fgcolour = '6C7AC9'
      zint.ZS.bgcolour = 'FFFFFF'
      zint.ZS.whitespace_width = 1
      zint.ZS.border_width = 1
      zint.ZS.scale = 5
      zint.ZS.symbology = BARCODE_DATAMATRIX

      ctxt = ' ! Hello World!'
      ref_ctxt &= new CString( len(clip(ctxt)) + 1)
      ref_ctxt = ctxt

      output_filename = 'test4.png'

      how_to_clip = -11
      rotate_angle = 0
      AU = 1 !   UTF-8
      pixel_format = 24

      picStr &= zint.ZB_Str_Image(ref_ctxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test4', 'Data Matrix', ref_ctxt, picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test5 -------------------------------------------------------------------------------------------------------------------
!  (QR Code),    (test5.png),    (picStr)

      zint.ZS.fgcolour = '000000'
      zint.ZS.bgcolour = 'FFFFFF'
      zint.ZS.whitespace_width = 2
      zint.ZS.border_width = 2
      zint.ZS.scale = 2
      zint.ZS.symbology = BARCODE_QRCODE

      clear(stxt)
      !stxt = 'ST00012|Name= " "|PersonalAcc=40702810055040012034|BankName=-   |BIC=044030653|CorrespAcc=30101810500000000653|KPP=781301001|PayeeINN=7813324244|lastName=  |persAcc=1538176|Sum=10000'
      stxt = 'ST00011|Name=  |PersonalAcc=40702810138250123017|BankName= ʻ|BIC=044525225|CorrespAcc=30101810400000000225|PayeeINN=6200098765|LastName=|FirstName=|MiddleName=|Purpose=  |PayerAddress=. . .10 .15|Sum=10000'
      ref_stxt &= stxt

      output_filename = 'test5.png'

      how_to_clip = -11 !     
      rotate_angle = 0
      AU = 1 !   UTF-8
      pixel_format = 1 !  

      picStr &= zint.ZB_Str_Image(ref_stxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test5', 'QR Code', stxt, picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test6 -------------------------------------------------------------------------------------------------------------------
!  (Maxicode),    ,    (picStr)

      zint.ZS.fgcolour = '00FF00'
      zint.ZS.bgcolour = '0000FF'
      zint.ZS.whitespace_width = 1
      zint.ZS.border_width = 1
      zint.ZS.scale = 1
      zint.ZS.symbology = BARCODE_MAXICODE

      ctxt = '  == Hello World!  ! ==  '

      output_filename = 'BMP'

      how_to_clip = -11
      rotate_angle = 0
      AU = 1 !   UTF-8
      pixel_format = 24

      picStr &= zint.ZB_Str_Image(ctxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test6', 'Maxicode', clip( left(ctxt) ), picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test7 -------------------------------------------------------------------------------------------------------------------
!  (PDF417),    ,    (picStr)

      zint.ZS.fgcolour = '000000'
      zint.ZS.bgcolour = 'FFFFFF'
      zint.ZS.whitespace_width = 1
      zint.ZS.border_width = 1
      zint.ZS.scale = 1
      zint.ZS.symbology = BARCODE_PDF417

      stxt = '    . Hello everybody.   '

      output_filename = 'JPEG'

      how_to_clip = -11
      rotate_angle = 0
      AU = 1 !   UTF-8
      pixel_format = 1

      picStr &= zint.ZB_Str_Image(stxt, how_to_clip, rotate_angle, AU, clip(output_filename), pixel_format) 
      view_code('Test7', 'PDF417', clip( left(stxt) ), picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      zint.ZS.option_1 = -1
      zint.ZS.option_2 = 0
      Dispose(picStr)
      zint.ZB_Clear()



! -------------------------------------------------------------------------------------------------------------------------
! -------------------------------------------------------------------------------------------------------------------------
! ZB_File_Image() -  -          .   -   .
! -------------------------------------------------------------------------------------------------------------------------
! -------------------------------------------------------------------------------------------------------------------------

! test8 -------------------------------------------------------------------------------------------------------------------
!  (Aztec),    (Test8.txt),    ,    (picStr)

      zint.ZS.fgcolour = '000000'
      zint.ZS.bgcolour = 'FFFFFF'
      zint.ZS.whitespace_width = 1
      zint.ZS.border_width = 1
      zint.ZS.scale = 2
      zint.ZS.symbology = BARCODE_AZTEC

      input_filename  = 'Test8.txt'  !    ANSI
      output_filename = 'PNG'

      rotate_angle = 0
      AU = 1 !   UTF-8
      pixel_format = 1

      is_UTF16 = 1 !      ?Rtf  View_Code()
      
      picStr &= zint.ZB_File_Image(input_filename, rotate_angle, AU, clip(output_filename), pixel_format)
      view_code('Test8 -   ', 'Aztec', '', picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)

      Dispose(picStr)
      zint.ZB_Clear()


! test9 -------------------------------------------------------------------------------------------------------------------
!  (QR Code),    (Test9.txt),    (test9.png),    (picStr)

      zint.ZS.fgcolour = '000000'
      zint.ZS.bgcolour = 'FFFFFF'
      zint.ZS.whitespace_width = 1
      zint.ZS.border_width = 1
      zint.ZS.scale = 3
      zint.ZS.symbology = BARCODE_QRCODE

      input_filename  = 'Test9.txt'  !    UTF-8
      output_filename = 'test9.png'

      rotate_angle = 0
      AU = 0 !    UTF-8,     UTF-8
      pixel_format = 1

      is_UTF16 = 1 !      ?Rtf  View_Code()
      
      picStr &= zint.ZB_File_Image(input_filename, rotate_angle, AU, clip(output_filename), pixel_format)
      view_code('Test9 -   ', 'QR Code', '', picStr, output_filename, zint.ZS.bitmap_width, zint.ZS.bitmap_height, rotate_angle)


   !  
   Dispose(picStr)
   Dispose(zint)
   FreeLibrary(adr_msvcrt)
   
   Return


!----------------------------------------------------------------------------------------------------------------------------------
View_Code Procedure(any testN, any comment, any code_text, *string pic_Str, string filename, long w_pic, long h_pic, long rotate)
!
!  
!
Check_Stretch string('F')

Win_View WINDOW('View'),AT(,,230,293),CENTER,GRAY,IMM,SYSTEM,FONT(,10,COLOR:Black),COLOR(0E1E1E1H)
        BUTTON('>'),AT(108,275,15,12),USE(?ViewPic),STD(STD:Close),FONT(,10,,FONT:bold),TIP(' Test'),TRN
        CHECK('   '),AT(14,2),USE(Check_Stretch),TRN,FONT(,10,COLOR:Black),COLOR(0E1E1E1H),VALUE('T','F')
        TEXT,AT(15,228,200,39),USE(?Rtf),BOXED,FLAT,VSCROLL,FONT('Arial',10,,,CHARSET:CYRILLIC),RTF(TEXT:FIELD)
        BOX,AT(14,14,202,202),USE(?BOX1),COLOR(COLOR:Black),LINEWIDTH(1)
        IMAGE(''),AT(15,15,200,200),USE(?Image),HVSCROLL,CENTERED
        STRING('String1'),AT(15,218),USE(?comment),FONT('Microsoft Sans Serif',10,,FONT:regular,CHARSET:CYRILLIC)
    END

    Code

      Open(Win_View)
      Display

      Win_View{Prop:Pixels} = 1    
      Win_View{Prop:Text} = testN
      ?Image{PROP:ImageBits}   = pic_Str
      ?comment{Prop:Text} = clip(comment) & ',  : ' & clip(filename) & |
                            ',  wh: ' & clip(left(format(w_pic, @n_5))) & 'x' & clip(left(format(h_pic, @n_5))) & |
                            ',  : ' & clip(left(format(rotate, @N_3))) & chr(176)

      hRtf# = ?Rtf{PROP:Handle}
      Case is_UTF16
           of 1
              If AU = 0 then
                 str_to_UTF16(clip(input_filename), 65001, hRtf#)   ! UTF-8 -> UTF-16 
               else  
                 str_to_UTF16(clip(input_filename), 0, hRtf#)   ! ANSI -> UTF-16
              .
              SendMessage(hRtf#, 1088, 13, 0)    !       ?Rtf
              clear_Clipboard(hRtf#)
              is_UTF16 = 0
           of 0
              ?Rtf{Prop:text} = code_text
      .

      x0# = ?Image{Prop:xpos}
      y0# = ?Image{Prop:ypos}
      h0# = ?Image{Prop:Height}
      w0# = ?Image{Prop:Width}
      xc# = x0# + w0#/2
      yc# = y0# + h0#/2
      psc# = 0
      If (w_pic > h_pic) then sc$ = h_pic/w_pic ; psc# =  1.
      If (w_pic < h_pic) then sc$ = w_pic/h_pic ; psc# = -1.
      Case psc#
           of  0   
           of  1
               wn# = w0#
               hn# = h0# * sc$
               xn# = x0#
               yn# = yc# - hn#/2
           of -1   
               wn# = w0# * sc$
               hn# = h0#
               xn# = xc# - wn#/2
               yn# = y0#
      .

      Accept
         If (Event() = 1) and (Accepted() = ?Check_Stretch) then
            Case Check_Stretch
                 of 'F'
                     ?Image{Prop:xpos}   = x0#
                     ?Image{Prop:ypos}   = y0#
                     ?Image{Prop:Height} = h0#
                     ?Image{Prop:Width}  = w0#
                     ?Image{Prop:Centered} = 1
                     ?Image{Prop:HScroll}  = 1
                     ?Image{Prop:VScroll}  = 1
                 of 'T'
                     ?Image{Prop:xpos}   = xn#
                     ?Image{Prop:ypos}   = yn#
                     ?Image{Prop:Height} = hn#
                     ?Image{Prop:Width}  = wn#
                     ?Image{Prop:Centered} = 0
                     ?Image{Prop:HScroll}  = 0
                     ?Image{Prop:VScroll}  = 0
            .
            Update()
         .
      .
   
   Return


!----------------------------------------------------------------------------------------------------------------------------------
load_file  Procedure(any filename, *long filelength)
!
!   (filename)       (file_content)
!
file_content &string
ref_filename &cstring

fd long
fs ulong

     Code
 
      ref_filename &= new CString( len(left(clip(filename))) + 1)
      ref_filename = filename

      fd = fopen(ref_filename)
      fs = fsize(fd)
 
      file_content &= new String(fs)
      filelength = fread(fd, file_content, fs)
      fclose(fd)
      
      Dispose(ref_filename)
      
   Return file_content


!----------------------------------------------------------------------------------------------------------------------------------
load_libs  Procedure()
!
!   msvcrt.dll
!
name_dll   cstring(32)
name_proc  cstring(32)
 
   Code

      ! msvcrt.dll -------------------------------------------------------------------------------------------------------
      name_dll   = 'msvcrt.dll' ; 
      adr_msvcrt = LoadLibrary(name_dll)

      name_proc = '_filelength' ;  h_size  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_open'       ;  h_open  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_read'       ;  h_read  = GetProcAddress (adr_msvcrt, name_proc)
      name_proc = '_close'      ;  h_close = GetProcAddress (adr_msvcrt, name_proc)
      
   Return  GetLastError()


!----------------------------------------------------------------------------------------------------------------------------------
str_to_UTF16  Procedure(string filename, ulong CP_input, long hwnd)
!
!   UTF-16  filename    Clipboard  hwnd
!
utf16      &string
len_utf16  long
umode      ulong
sfile      &string
len_source LONG
 
   Code
      
      sfile &= load_file(filename, filelength#)

      rb# = MultiByteToWideChar(CP_input, 0, address(sfile), filelength#, 0, 0)
      len_utf16 = rb# * 2
      utf16 &= new String(len_utf16)
      rns# = MultiByteToWideChar(CP_input, 0, address(sfile), filelength#, address(utf16), rb#)

      Dispose(sfile)

      hml#    = LocalAlloc(0, len_utf16)
      hutf16# = memcpy(hml#, address(utf16), len_utf16)

      ret#  = OpenClipboard(hwnd)
      ret#  = EmptyClipboard()
      umode = 13
      ret#  = SetClipboardData(umode, hutf16#)
      ret#  = CloseClipboard()

   Return


!----------------------------------------------------------------------------------------------------------------------------------
clear_Clipboard  Procedure(long hwnd)
!
!  Clipboard
!
 
   Code
      
      ret#  = OpenClipboard(hwnd)
      ret#  = EmptyClipboard()
      ret#  = CloseClipboard()

   Return
