   Map
      Module('zint_class').
   .

!----------------------------------------------------------------------------------------------------------------------------------
zint_symbol  Group, Type
symbology           long
height              long
whitespace_width    long
border_width        long
output_options      long
fgcolour            cstring(10)
bgcolour            cstring(10)
outfile             cstring(256)
scale               sreal
option_1            long
option_2            long
option_3            long
show_hrt            long
fontsize            long
input_mode          long
eci                 long
text                string(128)  
rows                long
width               long
primary             string(128)  
encoded_data        byte, dim(200, 143)         
row_height          long, dim(200)   ! Largest symbol is 189 x 189 Han Xin 
errtxt              string(100)
bitmap              &byte  
bitmap_width        long
bitmap_height       long
bitmap_byte_length  ulong
dot_size            sreal
vector              long  ! 
rendered            long 
debug               long.

! Tbarcode 7 codes !
BARCODE_CODE11               Equate( 1 )    ! Code 11
BARCODE_C25MATRIX            Equate( 2 )    ! Standard Code 2 of 5
BARCODE_C25INTER             Equate( 3 )	! Interleaved 2 of 5
BARCODE_C25IATA		         Equate( 4 )	! Code 2 of 5 IATA
BARCODE_C25LOGIC	         Equate( 6 )	! Code 2 of 5 Data Logic
BARCODE_C25IND		         Equate( 7 )	! Code 2 of 5 Industrial
BARCODE_CODE39		         Equate( 8 )	! Code 3 of 9 (Code 39)
BARCODE_EXCODE39	         Equate( 9 )	! Extended Code 3 of 9 (Code 39+)
BARCODE_EANX		         Equate( 13 )	! EAN
BARCODE_EANX_CHK             Equate( 14 )	! EAN + Check Digit
BARCODE_EAN128		         Equate( 16 )	! GS1-128 (UCC.EAN-128)
BARCODE_CODABAR		         Equate( 18 )	! Codabar
BARCODE_CODE128		         Equate( 20 )	! Code 128 (automatic subset switching)
BARCODE_DPLEIT		         Equate( 21 )	! Deutshe Post Leitcode
BARCODE_DPIDENT		         Equate( 22 )	! Deutshe Post Identcode
BARCODE_CODE16K		         Equate( 23 )	! Code 16K
BARCODE_CODE49		         Equate( 24 )	! Code 49
BARCODE_CODE93		         Equate( 25 )	! Code 93
BARCODE_FLAT		         Equate( 28 )	! Flattermarken
BARCODE_RSS14		         Equate( 29 )	! GS1 DataBar-14
BARCODE_RSS_LTD		         Equate( 30 )	! GS1 DataBar Limited
BARCODE_RSS_EXP		         Equate( 31 )	! GS1 DataBar Extended
BARCODE_TELEPEN		         Equate( 32 )	! Telepen Alpha
BARCODE_UPCA		         Equate( 34 )	! UPC A
BARCODE_UPCA_CHK             Equate( 35 )	! UPC A + Check Digit
BARCODE_UPCE		         Equate( 37 )	! UPC E
BARCODE_UPCE_CHK             Equate( 38 )	! UPC E + Check Digit
BARCODE_POSTNET		         Equate( 40 )	! PostNet
BARCODE_MSI_PLESSEY	         Equate( 47 )	! MSI Plessey
BARCODE_FIM		             Equate( 49 )	! FIM
BARCODE_LOGMARS		         Equate( 50 )	! LOGMARS
BARCODE_PHARMA		         Equate( 51 )	! Pharmacode One-Track
BARCODE_PZN		             Equate( 52 )	! PZN
BARCODE_PHARMA_TWO	         Equate( 53 )	! Pharmacode Two-Track
BARCODE_PDF417		         Equate( 55 )	! PDF417
BARCODE_PDF417TRUNC	         Equate( 56 )	! PDF417 Truncated
BARCODE_MAXICODE	         Equate( 57 )	! Maxicode
BARCODE_QRCODE		         Equate( 58 )	! QR Code
BARCODE_CODE128B	         Equate( 60 )	! Code 128 (Subset B)
BARCODE_AUSPOST		         Equate( 63 )	! Australia Post Standard Customer
BARCODE_AUSREPLY	         Equate( 66 )	! Australia Post Reply Paid
BARCODE_AUSROUTE	         Equate( 67 )	! Australia Post Routing
BARCODE_AUSREDIRECT	         Equate( 68 )	! Australia Post Redirection
BARCODE_ISBNX		         Equate( 69 )	! ISBN (EAN-13 with verification stage)
BARCODE_RM4SCC		         Equate( 70 )	! Royal Mail 4 State (RM4SCC)
BARCODE_DATAMATRIX	         Equate( 71 )	! Data Matrix ECC200
BARCODE_EAN14		         Equate( 72 )	! EAN-14
BARCODE_VIN                  Equate( 73 )	! Vehincle Identification Number (America)
BARCODE_CODABLOCKF           Equate( 74 )	! Codablock-F
BARCODE_NVE18		         Equate( 75 )	! NVE-18
BARCODE_JAPANPOST	         Equate( 76 )	! Japanese Postal Code
BARCODE_KOREAPOST	         Equate( 77 )	! Korea Post
BARCODE_RSS14STACK           Equate( 79 )	! GS1 DataBar-14 Stacked
BARCODE_RSS14STACK_OMNI      Equate( 80 )	! GS1 DataBar-14 Stacked Omnidirectional
BARCODE_RSS_EXPSTACK	     Equate( 81 )	! GS1 DataBar Expanded Stacked
BARCODE_PLANET	             Equate( 82 )	! PLANET
BARCODE_MICROPDF417          Equate( 84 )	! MicroPDF417
BARCODE_ONECODE	             Equate( 85 )	! USPS OneCode
BARCODE_PLESSEY	             Equate( 86 )   ! Plessey Code

! Tbarcode 8 codes !
BARCODE_TELEPEN_NUM	         Equate( 87 )	! Telepen Numeric
BARCODE_ITF14	             Equate( 89 )	! ITF-14
BARCODE_KIX		             Equate( 90 )	! Dutch Post KIX Code
BARCODE_AZTEC	             Equate( 92 )	! Aztec Code
BARCODE_DAFT	             Equate( 93 )	! DAFT Code
BARCODE_MICROQR	   	         Equate( 97 )	! Micro QR Code

! Tbarcode 9 codes !
BARCODE_HIBC_128	         Equate( 98 )   ! HIBC Code 128
BARCODE_HIBC_39		         Equate( 99 )   ! HIBC Code 39
BARCODE_HIBC_DM		         Equate( 102 )  ! HIBC Data Matrix ECC200
BARCODE_HIBC_QR		         Equate( 104 )  ! HIBC QR Code
BARCODE_HIBC_PDF	         Equate( 106 )  ! HIBC PDF417
BARCODE_HIBC_MICPDF	         Equate( 108 )  ! HIBC MicroPDF417
BARCODE_HIBC_BLOCKF	         Equate( 110 )  ! 
BARCODE_HIBC_AZTEC	         Equate( 112 )  ! HIBC Aztec Code

! Tbarcode 10 codes !
BARCODE_DOTCODE              Equate( 115 )  ! DotCode
BARCODE_HANXIN               Equate( 116 )  ! Han Xin (Chinese Sensible) Code
    		
!Tbarcode 11 codes!
BARCODE_MAILMARK             Equate( 121 )	! Royal Mail 4-State Mailmark

! Zint specific !
BARCODE_AZRUNE		         Equate( 128 )	! Aztec Runes
BARCODE_CODE32		         Equate( 129 )	! Code 32
BARCODE_EANX_CC		         Equate( 130 )	! Composite Symbol with EAN linear component
BARCODE_EAN128_CC	         Equate( 131 )	! Composite Symbol with GS1-128 linear component
BARCODE_RSS14_CC	         Equate( 132 )	! Composite Symbol with GS1 DataBar-14 linear component
BARCODE_RSS_LTD_CC	         Equate( 133 )	! Composite Symbol with GS1 DataBar Limited component
BARCODE_RSS_EXP_CC	         Equate( 134 )	! Composite Symbol with GS1 DataBar Extended component
BARCODE_UPCA_CC		         Equate( 135 )	! Composite Symbol with UPC A linear component
BARCODE_UPCE_CC		         Equate( 136 )	! Composite Symbol with UPC E linear component
BARCODE_RSS14STACK_CC	     Equate( 137 )	! Composite Symbol with GS1 DataBar-14 Stacked component
BARCODE_RSS14_OMNI_CC	     Equate( 138 )	! Composite Symbol with GS1 DataBar-14 Stacked Omnidirectional component
BARCODE_RSS_EXPSTACK_CC	     Equate( 139 )	! Composite Symbol with GS1 DataBar Expanded Stacked component
BARCODE_CHANNEL		         Equate( 140 )	! Channel Code
BARCODE_CODEONE		         Equate( 141 )	! Code One
BARCODE_GRIDMATRIX	         Equate( 142 )	! Grid Matrix
BARCODE_UPNQR                Equate( 143 )	! UPNQR (Univerzalni Placilni Nalog QR)
BARCODE_ULTRA                Equate( 144 )
BARCODE_RMQR                 Equate( 145 )  ! Rectangular Micro QR Code (rMQR)

! Output options
! 0 - No options selected
BARCODE_BIND	             Equate( 2 )	! Boundary bars above and below the symbol and between rows if stacking multiple symbols
BARCODE_BOX	                 Equate( 4 )	! Add a box surrounding the symbol and whitespace
BARCODE_STDOUT               Equate( 8 )	! Output the file to stdout
READER_INIT	                 Equate( 16 )	! Add a reader initialisation symbol to the data before encoding
SMALL_TEXT	                 Equate( 32 )	! Use a smaller font for the human readable text
BOLD_TEXT                    Equate( 64 )	! Embolden the human readable text
CMYK_COLOUR                  Equate( 128 )	! Select the CMYK colour space option for encapsulated PostScript files
BARCODE_DOTTY_MODE           Equate( 256 )	! Plot a matrix symbol using dots rather than squares
GS1_GS_SEPARATOR             Equate( 512 )  ! Use GS instead FNC1 as GS1 separator

! Input data types
DATA_MODE	                 Equate( 0 )    ! Uses full ASCII range interpreted as Latin-1 or binary data
UNICODE_MODE                 Equate( 1 )    ! Uses pre-formatted UTF-8 input
GS1_MODE	                 Equate( 2 )    ! Encodes GS1 data using FNC1 characters
ESCAPE_MODE                  Equate( 8 )    ! Process input data for escape sequences

! Data Matrix specific options
DM_SQUARE                    Equate( 100 )
DM_DMRE	                     Equate( 101 )

! Warning and error conditions
ZINT_WARN_INVALID_OPTION     Equate( 2 )	!     ZS   ,
                                            !  Zint ,     ,    -.

ZINT_WARN_USES_ECI           Equate( 3 )	! Zint    ECI.      .

ZINT_ERROR_TOO_long		     Equate( 5 )	!          .    . The input data is too long or too short for the selected symbology. No symbol has been generated.

ZINT_ERROR_INVALID_DATA	     Equate( 6 )	!      ,     ,
                                            ! ,     EAN.    .

ZINT_ERROR_INVALID_CHECK	 Equate( 7 )	!  ISBN    .    .

ZINT_ERROR_INVALID_OPTION	 Equate( 8 )	!     ZS   ,  Zint   ,
                                            !     .    .

ZINT_ERROR_ENCODING_PROBLEM	 Equate( 9 )	!      .  ,    .
                                            !   ,      .

ZINT_ERROR_FILE_ACCESS	     Equate( 10 )	! Zint      .        .

ZINT_ERROR_MEMORY		     Equate( 11 )	! Zint   . ,      .

!----------------------------------------------------------------------------------------------------------------------------------

   Map

      Module('zint.dll')
         ZBarcode_Create                 (), ulong, C, dll(1)
         ZBarcode_Clear                  (*zint_symbol symbol), C, raw, dll(1)
         ZBarcode_Delete                 (*zint_symbol symbol), C, raw, dll(1)

         ZBarcode_Encode_and_Buffer      (*zint_symbol symbol, *cstring source, long length, long rotate_angle), long, C, raw, dll(1)

         ZBarcode_ValidID                (long symbol_id), long, C, dll(1)
         ZBarcode_Version                (), long, C, dll(1) 
      .

   .

!----------------------------------------------------------------------------------------------------------------------------------
zintClass Class, Type , Module('zint_Class.clw'), Link('zint_Class.clw',_ABCLinkMode_), dll(_ABCDllMode_) 

ZS Group(zint_symbol).

Construct             Procedure ()
Destruct              Procedure ()

ZB_Create             Procedure (), long
ZB_Clear              Procedure ()
ZB_Delete             Procedure ()

ZB_Encode_and_Buffer  Procedure (any source, long length, long rotate_angle=0), long, Proc

ZB_ValidID            Procedure (long symbol_id), long
ZB_Version            Procedure (), long

!----------------------------------------------------------------------------------------------------------------------------------

ZB_Str_Image   Procedure (any source, long how_to_clip, long rotate_angle=0, long source_encoding, any NFE, long pixel_format, ulong CP_input=0), *string
ZB_File_Image  Procedure (any filename, long rotate_angle, long file_encoding, any NFE, long pixel_format, ulong CP_input=0), *string

.
